﻿SET FOREIGN_KEY_CHECKS=0
;

DROP PROCEDURE IF EXISTS INSERT_CATEGORY_SCHEME
;
DROP PROCEDURE IF EXISTS INSERT_CONCEPT_SCHEME
;
DROP PROCEDURE IF EXISTS INSERT_DATACONSUMER_SCHEME
;
DROP PROCEDURE IF EXISTS INSERT_DATAPROVIDER_SCHEME
;
DROP PROCEDURE IF EXISTS INSERT_ORGANISATION_UNIT_SCH
;
DROP PROCEDURE IF EXISTS INSERT_AGENCY_SCHEME
;

DROP PROCEDURE IF EXISTS INSERT_COMPONENT
;

DROP PROCEDURE IF EXISTS INSERT_CONCEPT
;

DROP PROCEDURE IF EXISTS INSERT_CODELIST
;

DROP PROCEDURE IF EXISTS INSERT_DATAFLOW
;

DROP PROCEDURE IF EXISTS INSERT_STRUCTURE_USAGE
;

DROP PROCEDURE IF EXISTS INSERT_MSD
;

DROP PROCEDURE IF EXISTS INSERT_METADATAFLOW
;

DROP PROCEDURE IF EXISTS INSERT_METADATA_TARGET
;

DROP PROCEDURE IF EXISTS INSERT_TARGET_OBJECT
;

DROP PROCEDURE IF EXISTS INSERT_REPORT_STRUCTURE
;

DROP PROCEDURE IF EXISTS INSERT_METADATA_ATTRIBUTE
;

DROP PROCEDURE IF EXISTS INSERT_COMPONENT_COMMON
;

DROP PROCEDURE IF EXISTS INSERT_ITEM_SCHEME
;

DROP PROCEDURE IF EXISTS INSERT_PROVISION_AGREEMENT
;

ALTER TABLE CONCEPT ADD COLUMN CL_ID BIGINT AFTER CON_SCH_ID
;
ALTER TABLE COMPONENT CHANGE COMP_ID COMP_ID BIGINT NOT NULL
;

CREATE TABLE METADATA_ATTRIBUTE(
	`MTD_ATTR_ID` bigint NOT NULL,
	`ID` varchar(50) NOT NULL,
	`MIN_OCCURS` int NULL,
	`MAX_OCCURS` int NULL,
	`IS_PRESENTATIONAL` Tinyint NULL,
	`PARENT` bigint NULL,
	`CON_ID` bigint NOT NULL,
	`CL_ID` bigint NULL,
	`RS_ID` bigint NOT NULL,
 PRIMARY KEY (MTD_ATTR_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE ITEM_SCHEME(
	`ITEM_SCHEME_ID` bigint NOT NULL,
 PRIMARY KEY (ITEM_SCHEME_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;


CREATE TABLE CONCEPT_ROLE(
	`COMP_ID` bigint NOT NULL,
	`CON_ID` bigint NOT NULL,
 PRIMARY KEY (COMP_ID,CON_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE TARGET_OBJECT(
	`TARGET_OBJ_ID` bigint NOT NULL,
	`ID` varchar(50) NOT NULL,
	`ITEM_SCHEME_ID` bigint NULL,
	`MDT_ID` bigint NOT NULL,
	`TYPE` varchar(50) NOT NULL,
PRIMARY KEY (TARGET_OBJ_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE COMPONENT_COMMON(
	`COMP_ID` bigint AUTO_INCREMENT NOT NULL,
PRIMARY KEY (COMP_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE STRUCTURE_USAGE(
	`SU_ID` bigint NOT NULL,
  PRIMARY KEY (SU_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

 
CREATE TABLE METADATA_STRUCTURE_DEFINITION(
	`MSD_ID` bigint NOT NULL,
PRIMARY KEY (MSD_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE METADATA_TARGET(
	`MDT_ID` bigint NOT NULL,
	`MSD_ID` bigint NOT NULL,
PRIMARY KEY (MDT_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE METADATAFLOW(
	`MSD_ID` bigint NOT NULL,
	`MDF_ID` bigint NOT NULL,
 PRIMARY KEY (MDF_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE REPORT_STRUCTURE(
	`RS_ID` bigint NOT NULL,
	`MSD_ID` bigint NOT NULL,
PRIMARY KEY (RS_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE REPORT_STRUCTURE_META_TARGET(
	`RS_ID` bigint NOT NULL,
	`MDT_ID` bigint NOT NULL,
  PRIMARY KEY (RS_ID,MDT_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE CONCEPT_TEXT_FORMAT(
	`CON_ID` bigint NOT NULL,
    `FACET_TYPE_ENUM` bigint NOT NULL,
    `FACET_VALUE` nvarchar(1024),
 PRIMARY KEY (CON_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE PROVISION_AGREEMENT(
	`PA_ID` bigint NOT NULL,
	`SU_ID` bigint NOT NULL,
	`DP_ID` bigint NOT NULL,
  PRIMARY KEY (PA_ID) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8
;

CREATE TABLE REGISTRATION (
	DR_ID BIGINT NOT NULL AUTO_INCREMENT,
	ID VARCHAR(50) NULL,
	VALID_FROM datetime NULL,
    VALID_TO datetime NULL,
    LAST_UPDATED datetime NULL,
    INDEX_TIME_SERIES BOOL NOT NULL DEFAULT 0,
    INDEX_DATA_SET BOOL NOT NULL DEFAULT 0,
    INDEX_ATTRIBUTES BOOL NOT NULL DEFAULT 0,
    INDEX_REPORTING_PERIOD BOOL NOT NULL DEFAULT 0,
    PA_ID bigint NOT NULL,
    DATA_SOURCE_ID bigint NOT NULL,
    PRIMARY KEY(DR_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 
;

CREATE TABLE DATA_SOURCE (
   DATA_SOURCE_ID bigint NOT NULL AUTO_INCREMENT,
   -- ID VARCHAR(50) NULL, Doubled checked and doesn't appear to be a need for an ID.
   DATA_URL nvarchar(500) NOT NULL,
   WSDL_URL nvarchar(500) NULL,
   WADL_URL nvarchar(500) NULL,
   IS_SIMPLE BOOL NOT NULL,
   IS_REST BOOL NOT NULL,
   IS_WS BOOL NOT NULL,
   PRIMARY KEY(DATA_SOURCE_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 
;

ALTER TABLE CONCEPT ADD CONSTRAINT CONCEPT_CODELIST 
	FOREIGN KEY (CL_ID) REFERENCES CODELIST (CL_ID)
;



ALTER TABLE `PROVISION_AGREEMENT`  ADD  CONSTRAINT `FK_PROVISION_AGREEMENT_ARTEFACT` FOREIGN KEY(`PA_ID`)
REFERENCES `ARTEFACT` (`ART_ID`)
ON DELETE CASCADE
;

ALTER TABLE `PROVISION_AGREEMENT`  ADD  CONSTRAINT `FK_PROVISION_AGREEMENT_STRUCTURE_USAGE` FOREIGN KEY(`SU_ID`)
REFERENCES `STRUCTURE_USAGE` (`SU_ID`)
;
ALTER TABLE REGISTRATION ADD CONSTRAINT FK_REGISTRATION_PROVISION FOREIGN KEY (PA_ID) 
REFERENCES PROVISION_AGREEMENT (PA_ID)
;

ALTER TABLE REGISTRATION ADD CONSTRAINT FK_REGISTRATION_DATASOURCE FOREIGN KEY (DATA_SOURCE_ID)
REFERENCES DATA_SOURCE (DATA_SOURCE_ID)
ON DELETE CASCADE
;
ALTER TABLE `CONCEPT_TEXT_FORMAT`  ADD  CONSTRAINT `FK_CONCEPT_TEXT_FORMAT_CONCEPT` FOREIGN KEY(`CON_ID`)
REFERENCES `CONCEPT` (`CON_ID`)
;

ALTER TABLE `CONCEPT_TEXT_FORMAT`  ADD  CONSTRAINT `FK_CONCEPT_TEXT_FORMAT_ENUMERATIONS` FOREIGN KEY(`FACET_TYPE_ENUM`)
REFERENCES `ENUMERATIONS` (`ENUM_ID`)
;

ALTER TABLE `METADATA_ATTRIBUTE`  ADD  CONSTRAINT `FK_METADATA_ATTRIBUTE_CODELIST` FOREIGN KEY(`CL_ID`)
REFERENCES `CODELIST` (`CL_ID`)
;

ALTER TABLE `METADATA_ATTRIBUTE`  ADD  CONSTRAINT `FK_METADATA_ATTRIBUTE_COMPONENT_COMMON` FOREIGN KEY(`MTD_ATTR_ID`)
REFERENCES `COMPONENT_COMMON` (`COMP_ID`)
;

ALTER TABLE `METADATA_ATTRIBUTE`  ADD  CONSTRAINT `FK_METADATA_ATTRIBUTE_CONCEPT` FOREIGN KEY(`CON_ID`)
REFERENCES `CONCEPT` (`CON_ID`)
;

ALTER TABLE `METADATA_ATTRIBUTE`  ADD  CONSTRAINT `FK_METADATA_ATTRIBUTE_METADATA_ATTRIBUTE` FOREIGN KEY(`PARENT`)
REFERENCES `METADATA_ATTRIBUTE` (`MTD_ATTR_ID`)
;

ALTER TABLE `METADATA_ATTRIBUTE`  ADD  CONSTRAINT `FK_METADATA_ATTRIBUTE_REPORT_STRUCTURE` FOREIGN KEY(`RS_ID`)
REFERENCES `REPORT_STRUCTURE` (`RS_ID`)
;


ALTER TABLE `AGENCY_SCHEME`  ADD  CONSTRAINT `FK_AGENCY_SCHEME_ITEM_SCH` FOREIGN KEY(`AG_SCH_ID`)
REFERENCES `ITEM_SCHEME` (`ITEM_SCHEME_ID`)
ON DELETE CASCADE
;

ALTER TABLE `CONCEPT_SCHEME`   ADD  CONSTRAINT `CON_SCH_ITM_SCH_ID` FOREIGN KEY(`CON_SCH_ID`)
REFERENCES `ITEM_SCHEME` (`ITEM_SCHEME_ID`)
ON DELETE CASCADE
;

ALTER TABLE `DATACONSUMER_SCHEME`   ADD  CONSTRAINT `FK_DATACONSUMER_SCHEME_ITM_SCH_ID` FOREIGN KEY(`DC_SCH_ID`)
REFERENCES `ITEM_SCHEME` (`ITEM_SCHEME_ID`)
ON DELETE CASCADE
;

ALTER TABLE `DATAPROVIDER_SCHEME`   ADD  CONSTRAINT `FK_DATAPROVIDER_SCHEME_ITM_SCH_ID` FOREIGN KEY(`DP_SCH_ID`)
REFERENCES `ITEM_SCHEME` (`ITEM_SCHEME_ID`)
ON DELETE CASCADE
;

ALTER TABLE `ITEM_SCHEME`   ADD  CONSTRAINT `FK_ITEM_SCHEME_ARTEFACT` FOREIGN KEY(`ITEM_SCHEME_ID`)
REFERENCES `ARTEFACT` (`ART_ID`)
ON DELETE CASCADE
;

ALTER TABLE `CODELIST`   ADD  CONSTRAINT `CL_ID_ITM_SCM` FOREIGN KEY(`CL_ID`)
REFERENCES `ITEM_SCHEME` (`ITEM_SCHEME_ID`)
ON DELETE CASCADE
;

ALTER TABLE `ORGANISATION_UNIT_SCHEME`   ADD  CONSTRAINT `FK_ORGANISATION_UNIT_SCH_ITM_SCH` FOREIGN KEY(`ORG_UNIT_SCH_ID`)
REFERENCES `ITEM_SCHEME` (`ITEM_SCHEME_ID`)
ON DELETE CASCADE
;


ALTER TABLE `TARGET_OBJECT`   ADD  CONSTRAINT `FK_TARGET_OBJECT_To_ITEM_SCHEME` FOREIGN KEY(`ITEM_SCHEME_ID`)
REFERENCES `ITEM_SCHEME` (`ITEM_SCHEME_ID`)
;

ALTER TABLE `CONCEPT_ROLE`   ADD  CONSTRAINT `FK_CONCEPT_ROLE_COMPONENT` FOREIGN KEY(`COMP_ID`)
REFERENCES `COMPONENT` (`COMP_ID`)
ON DELETE CASCADE
;


ALTER TABLE `CONCEPT_ROLE`   ADD  CONSTRAINT `FK_CONCEPT_ROLE_CONCEPT` FOREIGN KEY(`CON_ID`)
REFERENCES `CONCEPT` (`CON_ID`)
;

ALTER TABLE `TARGET_OBJECT`   ADD  CONSTRAINT `FK_TARGET_OBJECT_To_CCOMMON` FOREIGN KEY(`TARGET_OBJ_ID`)
REFERENCES `COMPONENT_COMMON` (`COMP_ID`)
;


ALTER TABLE `TARGET_OBJECT`   ADD  CONSTRAINT `FK_TARGET_OBJECT_To_MDT` FOREIGN KEY(`MDT_ID`)
REFERENCES `METADATA_TARGET` (`MDT_ID`)
;


ALTER TABLE `COMPONENT_ANNOTATION`   ADD  CONSTRAINT `FK_COMPONENT_ANNOTATION_COMPONENT_COMMON` FOREIGN KEY(`COMP_ID`)
REFERENCES `COMPONENT_COMMON` (`COMP_ID`)
;


ALTER TABLE `COMPONENT`   ADD  CONSTRAINT `FK_COMPONENT_COMMON_COMPONENT` FOREIGN KEY(`COMP_ID`)
REFERENCES `COMPONENT_COMMON` (`COMP_ID`)
ON DELETE CASCADE
;


ALTER TABLE `METADATAFLOW`   ADD  CONSTRAINT `FK_METADATAFLOW_METADATA_STRUCTURE_DEFINITION` FOREIGN KEY(`MSD_ID`)
REFERENCES `METADATA_STRUCTURE_DEFINITION` (`MSD_ID`)
;


ALTER TABLE `METADATAFLOW`   ADD  CONSTRAINT `FK_METADATAFLOW_STRUCTURE_USAGE` FOREIGN KEY(`MDF_ID`)
REFERENCES `STRUCTURE_USAGE` (`SU_ID`)
ON DELETE CASCADE
;

ALTER TABLE `METADATA_TARGET`   ADD  CONSTRAINT `FK_METADATA_TARGET_TO_ITEM` FOREIGN KEY(`MDT_ID`)
REFERENCES `ITEM` (`ITEM_ID`)
;


ALTER TABLE `METADATA_TARGET`   ADD  CONSTRAINT `FK_METADATA_TARGET_TO_MSD` FOREIGN KEY(`MSD_ID`)
REFERENCES `METADATA_STRUCTURE_DEFINITION` (`MSD_ID`)
;

ALTER TABLE `METADATA_STRUCTURE_DEFINITION`   ADD  CONSTRAINT `FK_MSD_TO_ARTEFACT` FOREIGN KEY(`MSD_ID`)
REFERENCES `ARTEFACT` (`ART_ID`)
;

ALTER TABLE `REPORT_STRUCTURE`   ADD  CONSTRAINT `FK_REPORT_STRUCTURE_To_ITEM` FOREIGN KEY(`RS_ID`)
REFERENCES `ITEM` (`ITEM_ID`)
;


ALTER TABLE `REPORT_STRUCTURE`   ADD  CONSTRAINT `FK_REPORT_STRUCTURE_To_MSD` FOREIGN KEY(`MSD_ID`)
REFERENCES `METADATA_STRUCTURE_DEFINITION` (`MSD_ID`)
;


ALTER TABLE `REPORT_STRUCTURE_META_TARGET`   ADD  CONSTRAINT `FK_REPORT_STRUCTURE_META_TARGET_METADATA_TARGET` FOREIGN KEY(`MDT_ID`)
REFERENCES `METADATA_TARGET` (`MDT_ID`)
;


ALTER TABLE `REPORT_STRUCTURE_META_TARGET`   ADD  CONSTRAINT `FK_REPORT_STRUCTURE_META_TARGET_REPORT_STRUCTURE` FOREIGN KEY(`RS_ID`)
REFERENCES `REPORT_STRUCTURE` (`RS_ID`)
;

ALTER TABLE TEXT_FORMAT DROP FOREIGN KEY FK_TEXT_FORMAT_COMPONENT
;

ALTER TABLE TEXT_FORMAT ADD CONSTRAINT
	FK_TEXT_FORMAT_COMPONENT FOREIGN KEY
	(COMP_ID) REFERENCES COMPONENT_COMMON (COMP_ID) ON DELETE CASCADE
;

ALTER TABLE ATT_MEASURE DROP FOREIGN KEY FK_ATT_MEASURE_ATT
;

ALTER TABLE ATT_MEASURE ADD CONSTRAINT FK_ATT_MEASURE_ATT 
	FOREIGN KEY (ATT_COMP_ID) REFERENCES COMPONENT (COMP_ID)
	ON DELETE CASCADE
;

ALTER TABLE `PROVISION_AGREEMENT`  ADD  CONSTRAINT `FK_PROVISION_AGREEMENT_DATAPROVIDER` FOREIGN KEY(`DP_ID`)
REFERENCES `DATAPROVIDER` (`DP_ID`)
;

ALTER TABLE DATAFLOW   ADD  CONSTRAINT FK_DATAFLOW_STRUCTURE_USAGE FOREIGN KEY(DF_ID)
REFERENCES STRUCTURE_USAGE (SU_ID)
ON DELETE CASCADE
;

ALTER TABLE STRUCTURE_USAGE ADD CONSTRAINT FK_STRUCTURE_USAGE_ARTEFACT  FOREIGN KEY(SU_ID)
REFERENCES ARTEFACT (ART_ID)
ON DELETE CASCADE
;

ALTER TABLE CATEGORY_SCHEME  ADD  CONSTRAINT CAT_SCH_ITM_SCH_ID FOREIGN KEY(CAT_SCH_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
ON DELETE CASCADE
;

-- Add missing constraints from older versions of MSDB and drop obsolete constraints
DROP PROCEDURE IF EXISTS TMP_PROC
;

create procedure TMP_PROC()
begin
IF NOT EXISTS (SELECT NULL FROM information_schema.TABLE_CONSTRAINTS WHERE
                   CONSTRAINT_SCHEMA = DATABASE() AND
                   CONSTRAINT_NAME   = 'FK_COM_COL_MAPP_COLUMN_COLUMN' AND
                   CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
					ALTER TABLE COM_COL_MAPPING_COLUMN ADD CONSTRAINT FK_COM_COL_MAPP_COLUMN_COLUMN 
						FOREIGN KEY (COL_ID) REFERENCES DATASET_COLUMN (COL_ID);
END IF;
IF NOT EXISTS (SELECT NULL FROM information_schema.TABLE_CONSTRAINTS WHERE
                   CONSTRAINT_SCHEMA = DATABASE() AND
                   CONSTRAINT_NAME   = 'FK_COM_COL_MAPP_COLUMN_COLUMN' AND
                   CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
					ALTER TABLE COM_COL_MAPPING_COMPONENT ADD CONSTRAINT FK_COM_COL_MAPP_COMP_COMP 
						FOREIGN KEY (COMP_ID) REFERENCES COMPONENT (COMP_ID);
END IF;
IF NOT EXISTS (SELECT NULL FROM information_schema.TABLE_CONSTRAINTS WHERE
                   CONSTRAINT_SCHEMA = DATABASE() AND
                   CONSTRAINT_NAME   = 'FK_MAPPING_SET_MA_USER' AND
                   CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
ALTER TABLE MAPPING_SET ADD CONSTRAINT FK_MAPPING_SET_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID);

END IF;
IF EXISTS (SELECT  NULL FROM  information_schema.TABLE_CONSTRAINTS WHERE  CONSTRAINT_SCHEMA = DATABASE() AND CONSTRAINT_NAME   = 'FK_DATAFLOW_ARTEFACT' AND  CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
	ALTER TABLE DATAFLOW DROP FOREIGN KEY FK_DATAFLOW_ARTEFACT;
END IF;
IF EXISTS (SELECT  NULL FROM  information_schema.TABLE_CONSTRAINTS WHERE  CONSTRAINT_SCHEMA = DATABASE() AND CONSTRAINT_NAME   = 'CAT_SCH_ART_ID' AND  CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
	ALTER TABLE CATEGORY_SCHEME DROP FOREIGN KEY CAT_SCH_ART_ID;
END IF;
IF EXISTS (SELECT  NULL FROM  information_schema.TABLE_CONSTRAINTS WHERE  CONSTRAINT_SCHEMA = DATABASE() AND CONSTRAINT_NAME   = 'CL_ID' AND  CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
	ALTER TABLE CODELIST DROP FOREIGN KEY CL_ID;
END IF;

IF EXISTS (SELECT  NULL FROM  information_schema.TABLE_CONSTRAINTS WHERE  CONSTRAINT_SCHEMA = DATABASE() AND CONSTRAINT_NAME   = 'CON_SCH_ART_ID' AND  CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
	ALTER TABLE CONCEPT_SCHEME DROP FOREIGN KEY CON_SCH_ART_ID;
END IF;
IF EXISTS (SELECT  NULL FROM  information_schema.TABLE_CONSTRAINTS WHERE  CONSTRAINT_SCHEMA = DATABASE() AND CONSTRAINT_NAME   = 'FK_AGENCY_SCHEME_ARTEFACT' AND  CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
	ALTER TABLE AGENCY_SCHEME DROP FOREIGN KEY FK_AGENCY_SCHEME_ARTEFACT;
END IF;

IF EXISTS (SELECT  NULL FROM  information_schema.TABLE_CONSTRAINTS WHERE  CONSTRAINT_SCHEMA = DATABASE() AND CONSTRAINT_NAME   = 'FK_DATACONSUMER_SCHEME_ART_ID' AND  CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
	ALTER TABLE DATACONSUMER_SCHEME DROP FOREIGN KEY FK_DATACONSUMER_SCHEME_ART_ID;
END IF;

IF EXISTS (SELECT  NULL FROM  information_schema.TABLE_CONSTRAINTS WHERE  CONSTRAINT_SCHEMA = DATABASE() AND CONSTRAINT_NAME   = 'FK_DATAPROVIDER_SCHEME_ART_ID' AND  CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
	ALTER TABLE DATAPROVIDER_SCHEME DROP FOREIGN KEY FK_DATAPROVIDER_SCHEME_ART_ID;
END IF;

IF EXISTS (SELECT  NULL FROM  information_schema.TABLE_CONSTRAINTS WHERE  CONSTRAINT_SCHEMA = DATABASE() AND CONSTRAINT_NAME   = 'FK_ORGANISATION_UNIT_SCH_ART' AND  CONSTRAINT_TYPE   = 'FOREIGN KEY') THEN
	ALTER TABLE ORGANISATION_UNIT_SCHEME DROP FOREIGN KEY FK_ORGANISATION_UNIT_SCH_ART;
END IF;

end;
;

CALL TMP_PROC()
;

DROP PROCEDURE IF EXISTS TMP_PROC
;


CREATE PROCEDURE INSERT_COMPONENT(
	IN p_type varchar(50) ,
	IN p_id varchar(50) ,
	IN p_dsd_id bigint ,
	IN p_con_id bigint ,
	IN p_cl_id bigint,
	IN p_con_sch_id bigint,
	IN p_is_freq_dim int,
	IN p_is_measure_dim int,
	IN p_att_ass_level varchar(11),
	IN p_att_status varchar(11),
	IN p_att_is_time_format int,
	IN p_xs_attlevel_ds int,
	IN p_xs_attlevel_group int,
	IN p_xs_attlevel_section int,
	IN p_xs_attlevel_obs int,
	IN p_xs_measure_code varchar(50),
	OUT p_pk bigint) 
BEGIN
	call INSERT_COMPONENT_COMMON(p_pk);
	insert into COMPONENT (COMP_ID,ID, TYPE, DSD_ID, CON_ID, CL_ID, IS_FREQ_DIM, IS_MEASURE_DIM, ATT_ASS_LEVEL, ATT_STATUS, ATT_IS_TIME_FORMAT, XS_ATTLEVEL_DS, XS_ATTLEVEL_GROUP, XS_ATTLEVEL_SECTION, XS_ATTLEVEL_OBS, XS_MEASURE_CODE, CON_SCH_ID) 
		values (p_pk,p_id, p_type, p_dsd_id, p_con_id, p_cl_id, p_is_freq_dim, p_is_measure_dim, p_att_ass_level, p_att_status, p_att_is_time_format, p_xs_attlevel_ds, p_xs_attlevel_group, p_xs_attlevel_section, p_xs_attlevel_obs, p_xs_measure_code, p_con_sch_id);
END
;


CREATE PROCEDURE INSERT_CONCEPT(
	IN p_id varchar(150),
	IN p_con_sch_id bigint,
	IN p_parent_con_id bigint,
	IN p_cl_id bigint,
	OUT p_pk bigint) 
BEGIN
		insert into ITEM (ID) VALUES (p_id);
		set p_pk = LAST_INSERT_ID();
		insert into CONCEPT (CON_ID, CON_SCH_ID,PARENT_CONCEPT_ID,CL_ID) VALUES (p_pk, p_con_sch_id,p_parent_con_id,p_cl_id);
	
END
;

CREATE PROCEDURE INSERT_CODELIST(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
    IN p_is_partial int,
	OUT p_pk bigint)
BEGIN
	call INSERT_ARTEFACT (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO ITEM_SCHEME (ITEM_SCHEME_ID) values (p_pk);

	INSERT INTO CODELIST
           (CL_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END
;

CREATE PROCEDURE INSERT_STRUCTURE_USAGE(
	IN p_id varchar(50),
    IN p_version  varchar(50),
    IN p_agency varchar(50),
    IN p_valid_from   datetime,
    IN p_valid_to   datetime,
    IN p_is_final  bigint,
    IN p_uri  nvarchar(255),
    IN p_last_modified  datetime,
	OUT p_pk  bigint)
BEGIN
	 call INSERT_ARTEFACT(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
     insert into STRUCTURE_USAGE (SU_ID) VALUES (p_pk);
END
;


CREATE PROCEDURE INSERT_METADATAFLOW(
	IN p_id varchar(50),
    IN p_version  varchar(50),
    IN p_agency varchar(50),
    IN p_valid_from   datetime,
    IN p_valid_to   datetime,
    IN p_is_final  bigint,
    IN p_uri  nvarchar(50),
    IN p_last_modified  datetime,
	IN p_msd_id  bigint,
	OUT p_pk bigint)
BEGIN
	 call INSERT_STRUCTURE_USAGE(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	 INSERT INTO METADATAFLOW
           (MSD_ID,MDF_ID)
     VALUES
           (p_msd_id,p_pk);
END
;


CREATE PROCEDURE INSERT_MSD(
	IN p_id varchar(50),
    IN p_version  varchar(50),
    IN p_agency varchar(50),
    IN p_valid_from   datetime,
    IN p_valid_to   datetime,
    IN p_is_final  bigint,
    IN p_uri  nvarchar(50),
    IN p_last_modified  datetime,
	OUT p_pk  bigint)
BEGIN
	call INSERT_ARTEFACT(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	INSERT INTO METADATA_STRUCTURE_DEFINITION
           (MSD_ID)
     VALUES
           (p_pk);
	
END
;

CREATE PROCEDURE INSERT_METADATA_TARGET(
	IN p_id  varchar(150),
	IN p_MSD_ID bigint,
	OUT p_pk  bigint)
BEGIN
	insert into ITEM (ID) VALUES (p_id);
		set p_pk = LAST_INSERT_ID();
		insert into METADATA_TARGET (MDT_ID,MSD_ID) VALUES (p_pk,p_MSD_ID);
END
;

CREATE PROCEDURE INSERT_TARGET_OBJECT(
	IN p_id varchar(50),
	IN p_ITEM_SCHEME_ID bigint,
	IN p_MDT_ID bigint,
	IN p_TYPE varchar(50),
	OUT p_pk  bigint)
BEGIN
		call INSERT_COMPONENT_COMMON(p_pk);
		insert into TARGET_OBJECT (TARGET_OBJ_ID,ID,ITEM_SCHEME_ID,MDT_ID,TYPE) VALUES (p_pk,p_id,p_ITEM_SCHEME_ID,p_MDT_ID,p_TYPE);
		set p_pk = LAST_INSERT_ID();
END
;


CREATE PROCEDURE INSERT_REPORT_STRUCTURE(
	IN p_id  varchar(150),
	IN p_MSD_ID bigint,
	OUT p_pk  bigint)
BEGIN
	insert into ITEM (ID) VALUES (p_id);
		set p_pk = LAST_INSERT_ID();
		insert into REPORT_STRUCTURE (RS_ID,MSD_ID) VALUES (p_pk,p_MSD_ID);
END
;


CREATE PROCEDURE INSERT_METADATA_ATTRIBUTE(
	IN p_id varchar(50),
    IN p_MIN_OCCURS  int,
	IN p_MAX_OCCURS  int,
	IN p_IS_PRESENTATIONAL  Tinyint,
	IN p_PARENT  bigint,
	IN p_CON_ID  bigint,
	IN p_CL_ID  bigint,
	IN p_RS_ID  bigint,
	OUT p_pk  bigint)
BEGIN
	call INSERT_COMPONENT_COMMON(p_pk);
	INSERT INTO METADATA_ATTRIBUTE
           (MTD_ATTR_ID,ID,MIN_OCCURS,MAX_OCCURS,IS_PRESENTATIONAL,PARENT,CON_ID,CL_ID,RS_ID)
     VALUES
           (p_pk,p_id,p_MIN_OCCURS,p_MAX_OCCURS,p_IS_PRESENTATIONAL,p_PARENT,p_CON_ID,p_CL_ID,p_RS_ID);
	
END
;



CREATE PROCEDURE INSERT_COMPONENT_COMMON(
	OUT p_pk bigint
	)
BEGIN
	INSERT INTO COMPONENT_COMMON() VALUES();
	set p_pk = LAST_INSERT_ID();
END
;


CREATE PROCEDURE INSERT_ITEM_SCHEME(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
	OUT p_pk bigint)
BEGIN
    call INSERT_ARTEFACT(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	insert into ITEM_SCHEME (ITEM_SCHEME_ID) VALUES (p_pk);
END
;


CREATE PROCEDURE INSERT_PROVISION_AGREEMENT(
	IN p_id varchar(50),
    IN p_version  varchar(50),
    IN p_agency varchar(50),
    IN p_valid_from   datetime,
    IN p_valid_to   datetime,
    IN p_is_final  bigint,
    IN p_uri  nvarchar(50),
	IN p_last_modified  datetime,
	IN p_su_id bigint,
	IN p_dp_id bigint,
	OUT p_pk  bigint)
BEGIN
	call INSERT_ARTEFACT(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	INSERT INTO PROVISION_AGREEMENT
           (PA_ID,SU_ID,DP_ID)
     VALUES
           (p_pk,p_su_id,p_dp_id);
	
END
;

CREATE PROCEDURE INSERT_CATEGORY_SCHEME(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
    IN p_is_partial int,
	OUT p_pk bigint)
BEGIN
	call INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO CATEGORY_SCHEME
           (CAT_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END
;

CREATE PROCEDURE INSERT_CONCEPT_SCHEME(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
    IN p_is_partial int,
	OUT p_pk bigint)
BEGIN
	call INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO CONCEPT_SCHEME
           (CON_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END
;


CREATE PROCEDURE INSERT_DATACONSUMER_SCHEME(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
    IN p_is_partial int,
	OUT p_pk bigint)
BEGIN
	call INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO DATACONSUMER_SCHEME
           (DC_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END
;


CREATE PROCEDURE INSERT_DATAPROVIDER_SCHEME(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
    IN p_is_partial int,
	OUT p_pk bigint)
BEGIN
	call INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO DATAPROVIDER_SCHEME
           (DP_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END
;

CREATE PROCEDURE INSERT_ORGANISATION_UNIT_SCH(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
    IN p_is_partial int,
	OUT p_pk bigint)
BEGIN
	call INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO ORGANISATION_UNIT_SCHEME
           (ORG_UNIT_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END
;

CREATE PROCEDURE INSERT_AGENCY_SCHEME(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
    IN p_is_partial int,
	OUT p_pk bigint)
BEGIN
	call INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO AGENCY_SCHEME
           (AG_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END
;

CREATE PROCEDURE INSERT_DATAFLOW(
	IN p_id varchar(50),
	IN p_version varchar(50),
	IN p_agency varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_is_final int,
	IN p_uri nvarchar(255),
	IN p_last_modified datetime,
	IN p_dsd_id bigint,
	IN p_map_set_id bigint,
	OUT p_pk bigint)
BEGIN
     call INSERT_STRUCTURE_USAGE(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
INSERT INTO DATAFLOW
           (DF_ID
           ,DSD_ID
           ,MAP_SET_ID)
     VALUES
           (p_pk
           ,p_dsd_id
           ,p_map_set_id);
END
;
DROP PROCEDURE IF EXISTS INSERT_REGISTRATION
;

DROP PROCEDURE IF EXISTS INSERT_DATA_SOURCE
;

CREATE PROCEDURE INSERT_REGISTRATION (
	IN p_id varchar(50),
	IN p_valid_from datetime,
	IN p_valid_to datetime,
	IN p_last_updated datetime,
    IN p_index_ts bool,
    IN p_index_ds bool,
    IN p_index_attributes bool,
    IN p_index_reporting_period bool,
    IN p_pa_id bigint,
    IN p_datasource_id bigint,
	OUT p_pk bigint)
BEGIN
	insert into REGISTRATION (ID, VALID_FROM, VALID_TO, LAST_UPDATED, INDEX_TIME_SERIES, INDEX_DATA_SET, INDEX_ATTRIBUTES, INDEX_REPORTING_PERIOD, PA_ID, DATA_SOURCE_ID) 
    values (p_id, p_valid_from, p_valid_to, p_last_updated, p_index_ts, p_index_ds, p_index_attributes, p_index_reporting_period, p_pa_id, p_datasource_id);
	set p_pk = LAST_INSERT_ID();
END
;
CREATE PROCEDURE INSERT_DATA_SOURCE (
	IN p_data_url nvarchar(500),
    IN p_wsdl_url nvarchar(500),
    IN p_wadl_url nvarchar(500),
    IN p_is_simple bool,
    IN p_is_rest bool,
    IN p_is_ws bool,
	OUT p_pk bigint)
BEGIN
	insert into DATA_SOURCE (DATA_URL, WSDL_URL, WADL_URL, IS_SIMPLE, IS_REST, IS_WS) 
    values (p_data_url, p_wsdl_url, p_wadl_url, p_is_simple, p_is_rest, p_is_ws);
	set p_pk = LAST_INSERT_ID();
END
;
ALTER TABLE COMPONENT_COMMON CHANGE COMP_ID COMP_ID BIGINT NOT NULL
;

Insert into COMPONENT_COMMON (select comp_id from COMPONENT)
;

ALTER TABLE COMPONENT_COMMON CHANGE COMP_ID COMP_ID BIGINT NOT NULL AUTO_INCREMENT
;

Insert into ITEM_SCHEME 
SELECT CL_ID FROM CODELIST
UNION
SELECT DC_SCH_ID FROM DATACONSUMER_SCHEME
UNION
SELECT DP_SCH_ID FROM DATAPROVIDER_SCHEME
UNION
SELECT ORG_UNIT_SCH_ID FROM ORGANISATION_UNIT_SCHEME
UNION 
SELECT CON_SCH_ID FROM CONCEPT_SCHEME
UNION
SELECT CAT_SCH_ID FROM CATEGORY_SCHEME
UNION
SELECT AG_SCH_ID FROM AGENCY_SCHEME
;

INSERT INTO STRUCTURE_USAGE
SELECT DF_ID FROM DATAFLOW
;

SET FOREIGN_KEY_CHECKS=1
;

update DB_VERSION SET VERSION = '5.0'
;

